config/routes.rb
Rails.application.routes.draw do

  resources :posts
  devise_for :users
  root to: 'static#homepage'

end

app/models/admin_user.rb
class AdminUser < User

end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/post.rb
class Post < ApplicationRecord
  belongs_to :user
  validates_presence_of :date, :rationale

end

app/models/user.rb
class User < ApplicationRecord
  has_many :posts
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  validates_presence_of :first_name, :last_name
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  before_action :authenticate_user!
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
	before_action :set_post, only: [:show]
	
	def index
		@posts = Post.all
	end

	def new
		@post = Post.new
	end

	def create
		@post = Post.new(post_params)
		@post.user_id = current_user.id

		if @post.save
			redirect_to @post, notice: 'Your post was created successfully'
		else
			render :new
		end
	end

	def show
	end

	private

	  def post_params
	  	params.require(:post).permit(:date, :rationale)
	  end

	  def set_post
	  	@post = Post.find(params[:id])
	  end
end

app/controllers/static_controller.rb
class StaticController < ApplicationController

  def homepage
  end
end

app/helpers/application_helper.rb
module ApplicationHelper

  def active?(path)
    "active" if current_page?(path)
  end
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Overtime</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
      <%= render  "shared/nav" %>    
      <p class="notice"><%= notice %></p>
      <p class="alert"><%= alert %></p>
      <div class="container">
        <%= yield %>
      </div>
  </body>
</html>

app/views/posts/_post.html.erb
<tr>
  <td><%= post.id %></td>
  <td><%= post.date %></td>
  <td><%= post.user.last_name %></td>
  <td><%= truncate(post.rationale) %></td>
</tr>

app/views/posts/index.html.erb
<h1>Posts</h1>


<table class="table table-sm table-striped table-hover">
  <thead>
    <th>#</th>
    <th>Date</th>
    <th>User</th>
    <th>Rationale</th>
  </thead>
  <tbody>
    <%
=begin%>
 <%= render partial: "post" %> 
<%
=end%>
    <%= render @posts %>

  </tbody>
</table>

app/views/posts/new.html.erb
<%= form_for @post do |f| %>
  <%= f.date_field :date %>
  <%= f.text_area :rationale %>
  
  <%= f.submit 'Save' %>
<% end %>

app/views/posts/show.html.erb
<%= @post.inspect %>

app/views/shared/_nav.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand" href="#">Course Overtime</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="nav nav-tabs">
      <li class="nav-item">
        <%= link_to  "Home", root_path, :class => "nav-link #{active?(root_path)}"  %>    
      </li>
      <li class="nav-item">
        <%= link_to  "Times entries", posts_path, :class => "nav-link #{active?(posts_path)}" %>    
      </li>
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Account</a>
        <div class="dropdown-menu">
          <%= link_to  "Edit details", edit_user_registration_path, :class => "dropdown-item" %>
          <div class="dropdown-divider"></div>
          <%= link_to  "Logout", destroy_user_session_path, method: :delete, :class => "dropdown-item" %>
        </div>
      </li>
    </ul>
  </div>
</nav>